%module cpgplot

%include typemaps.i

%{
#include "cpgplot.h"
#include "arrayobject.h"
%}

%typemap(python,ignore) int *IOUTPUT (int ftemp) {
   ftemp = 131;
   $target = &ftemp;
}

%typemap(python,argout) int *IOUTPUT {
    PyObject *o;
    o = PyInt_FromLong( (long) *$source);
    $target = t_output_helper($target, o);
}

%typemap(python,argout) int *IINOUT {
    PyObject *o;
    o = PyInt_FromLong( (long) *$source);
    $target = t_output_helper($target, o);
}

%typemap(python,ignore) int MAXPT {
   $target = 0;
}

%typemap(python,check) int MAXPT {
   $target = ((PyArrayObject *) _obj2)->dimensions[0];
}

%typemap(python,ignore) float *QFOUTPUT (float ftemp){
   ftemp = 0.0;
   $target = &ftemp;
}

%typemap(python,in) float *QFOUTPUT (float ftemp) {
   ftemp = (float) PyFloat_AsDouble( $source);
   $target = &ftemp;
}

%typemap(python,argout) float *QFOUTPUT {
    PyObject *o;
    o = PyFloat_FromDouble( (double) *$source);
    $target = t_output_helper($target, o);
}


%typemap(python,in) float *FOUTPUT (float ftemp) {
   ftemp = (float) PyFloat_AsDouble( $source);
   $target = &ftemp;
}

%typemap(python,argout) float *FOUTPUT {
    PyObject *o;
    o = PyFloat_FromDouble( (double) *$source);
    $target = t_output_helper($target, o);
}


%typemap(python,ignore) char *QOUTPUT (char c_temp[132]) {
    $target = c_temp;
}

%typemap(python,argout) char *QOUTPUT {
    PyObject *o;
    o = PyString_FromString( $source);
    $target = t_output_helper($target, o);
}


%typemap(python,ignore) char *COUTPUT (char c_temp[10]) {
  $target = (char *) c_temp;
}

%typemap(python,argout) char *COUTPUT {
    PyObject *o;
    if ( _result == 1) {
     o = PyString_FromStringAndSize( (char *) $source, 1);
    } else {
     o = Py_None;
    }
    $target = t_output_helper($target, o);
}

%typemap(python,arginit) const float *ARRAY (long na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) const float *ARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, 'f');
   $target = (float *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const float *ARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}


%typemap(python,arginit) float *OARRAY (long na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) float *OARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   array= (PyArrayObject *) PyArray_Cast( o, 'f');
   $target = (float *) ( o->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) float *OARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}


%typemap(python,arginit) const int *ARRAY (long na[10]) {
    import_array();
    na[0] = 0;
}

%typemap(python,in) const int *ARRAY {
   PyArrayObject *array;
   PyArrayObject *o;
   PyArrayObject *a;
   na[0] += 1;
   o = (PyArrayObject *) $source;
   a = (PyArrayObject *)
       PyArray_ContiguousFromObject( $source, o->descr->type, 0, 0);
   array= (PyArrayObject *) PyArray_Cast( a, 'i');
   $target = (int *) ( array->data);
   na[na[0]] = (long ) array;
   Py_DECREF(a);
}

%typemap(python,argout) const int *ARRAY {
   int j;
   PyArrayObject *a;
   if (na[0] > 0) {
     for (j=1;j<=na[0];j++) {
       a = (PyArrayObject *) na[j];
       Py_DECREF(a);
     }
   }
   na[0] = 0;
}

%typemap(python,ignore) float *YLIMS {
}

%typemap(python,check) float *YLIMS {
    $target = (float *) malloc((_arg4-_arg3+1)*sizeof(float));
}

%typemap(python,argout) float *YLIMS {
    free((float *) $source);
}

%typemap(python,ignore) float *IARRAYRET0  (PyArrayObject *NewArray0) {
    import_array();
}

%typemap(python,check) float *IARRAYRET0 {
    int *naxes;
    int naxis = 1;
    naxes = (int *) malloc((naxis+1)*sizeof(int));
    naxes[0] = (int) 4;
    NewArray0 = (PyObject *) PyArray_FromDims(naxis, naxes, PyArray_FLOAT);
    $target = (float *) (( (PyArrayObject *) NewArray0)-> data);
    free((int *) naxes);
}

%typemap(python,argout) float *IARRAYRET0 {
    $target = t_output_helper($target, (PyObject *) NewArray0);
}

%typemap(python,ignore) float *IARRAYRET1  (PyArrayObject *NewArray1) {
    import_array();
}

%typemap(python,check) float *IARRAYRET1 {
    int *naxes;
    int naxis = 1;
    naxes = (int *) malloc((naxis+1)*sizeof(int));
    naxes[0] = (int) 4;
    NewArray1 = (PyObject *) PyArray_FromDims(naxis, naxes, PyArray_FLOAT);
    $target = (float *) (( (PyArrayObject *) NewArray1)-> data);
    free((int *) naxes);
}

%typemap(python,argout) float *IARRAYRET1 {
    $target = t_output_helper($target, (PyObject *) NewArray1);
}

typedef int Logical;

/*--------------------------*/


 void cpgarro(float x1, float y1, float x2, float y2);
 void cpgask(int flag);
 void cpgaxis(const char *opt, float x1, float y1, float x2, float y2, float v1, float v2, float step, int nsub, float dmajl, float dmajr, float fmin, float disp, float orient);
 int cpgband(int mode, int posn, float xref, float yref, float *FOUTPUT, float *FOUTPUT, char *COUTPUT);
 void cpgbbuf(void);
 int cpgbeg(int unit, const char *file, int nxsub, int nysub);
 void cpgbin(int nbin, const float *ARRAY, const float *ARRAY, int center);
 void cpgbox(const char *xopt, float xtick, int nxsub, const char *yopt, float ytick, int nysub);
 void cpgcirc(float xcent, float ycent, float radius);
 void cpgclos(void);

 void cpgctab(const float *ARRAY, const float *ARRAY, const float *ARRAY, const float *ARRAY, int nc, float contra, float bright);
 int cpgcurs(float *FOUTPUT, float *FOUTPUT, char *COUTPUT);
 void cpgdraw(float x, float y);
 void cpgebuf(void);
 void cpgend(void);
 void cpgenv(float xmin, float xmax, float ymin, float ymax, int just, int axis);
 void cpgeras(void);
 void cpgerr1(int dir, float x, float y, float e, float t);
 void cpgerrb(int dir, int n, const float *ARRAY, const float *ARRAY, const float *ARRAY, float t);
 void cpgerrx(int n, const float *ARRAY, const float *ARRAY, const float *ARRAY, float t);
 void cpgerry(int n, const float *ARRAY, const float *ARRAY, const float *ARRAY, float t);
 void cpgetxt(void);
 void cpghi2d(const float *ARRAY, int nxv, int nyv, int ix1, int ix2, int iy1, int iy2, const float *ARRAY, int ioff, float bias, Logical center, float *YLIMS);
 void cpghist(int n, const float *ARRAY, float datmin, float datmax, int nbin, int pgflag);
 void cpgiden(void);
 void cpglab(const char *xlbl, const char *ylbl, const char *toplbl);
 void cpglcur(int MAXPT, int *INOUT, float *OARRAY, float *OARRAY);
 void cpgldev(void);
 void cpglen(int units, const char *string, float *QFOUTPUT, float *QFOUTPUT);
 void cpgmove(float x, float y);
 void cpgmtxt(const char *side, float disp, float coord, float fjust, const char *text);
 void cpgncur(int MAXPT, int *INOUT, float *OARRAY, float *OARRAY, int symbol);
 void cpgnumb(int mm, int pp, int form, char *QOUTPUT, int *IOUTPUT);
 void cpgolin(int MAXPT, int *INOUT, float *OARRAY, float *OARRAY, int symbol);
 int cpgopen(const char *device);
 void cpgpage(void);
 void cpgpanl(int nxc, int nyc);
 void cpgpap(float width, float aspect);
 void cpgpixl(const int *ia, int idim, int jdim, int i1, int i2, int j1, int j2, float x1, float x2, float y1, float y2);
 void cpgpoly(int n, const float *ARRAY, const float *ARRAY);
 void cpgpt(int n, const float *ARRAY, const float *ARRAY, int symbol);
 void cpgpt1(float xpt, float ypt, int symbol);
 void cpgptxt(float x, float y, float angle, float fjust, const char *text);
 void cpgqah(int *IOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqcf(int *IOUTPUT);
 void cpgqch(float *QFOUTPUT);
 void cpgqci(int *IOUTPUT);
 void cpgqcir(int *IOUTPUT, int *IOUTPUT);
 void cpgqclp(int *IOUTPUT);
 void cpgqcol(int *IOUTPUT, int *IOUTPUT);
 void cpgqcr(int ci, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqcs(int units, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqdt(int n, char *QOUTPUT, int *IOUTPUT, char *QOUTPUT, int *IOUTPUT, int *IOUTPUT);
 void cpgqfs(int *IOUTPUT);
 void cpgqhs(float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqid(int *IOUTPUT);
 void cpgqinf(const char *item, char *QOUTPUT, int *IOUTPUT);
 void cpgqitf(int *IOUTPUT);
 void cpgqls(int *IOUTPUT);
 void cpgqlw(int *IOUTPUT);
 void cpgqndt(int *IOUTPUT);
 void cpgqpos(float *QFOUTPUT, float *QFOUTPUT);
 void cpgqtbg(int *IOUTPUT);
 void cpgqtxt(float x, float y, float angle, float fjust, const char *text, float *IARRAYRET0, float *IARRAYRET1);
 void cpgqvp(int units, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqvsz(int units, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgqwin(float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT, float *QFOUTPUT);
 void cpgrect(float x1, float x2, float y1, float y2);
 float cpgrnd(float x, int *nsub);
 void cpgrnge(float x1, float x2, float *xlo, float *xhi);
 void cpgsah(int fs, float angle, float barb);
 void cpgsave(void);
 void cpgunsa(void);
 void cpgscf(int font);
 void cpgsch(float size);
 void cpgsci(int ci);
 void cpgscir(int icilo, int icihi);
 void cpgsclp(int state);
 void cpgscr(int ci, float cr, float cg, float cb);
 void cpgscrl(float dx, float dy);
 void cpgscrn(int ci, const char *name, int *ier);
 void cpgsfs(int fs);
 void cpgshls(int ci, float ch, float cl, float cs);
 void cpgshs(float angle, float sepn, float phase);
 void cpgsitf(int itf);
 void cpgslct(int id);
 void cpgsls(int ls);
 void cpgslw(int lw);
 void cpgstbg(int tbci);
 void cpgsubp(int nxsub, int nysub);
 void cpgsvp(float xleft, float xright, float ybot, float ytop);
 void cpgswin(float x1, float x2, float y1, float y2);
 void cpgtbox(const char *xopt, float xtick, int nxsub, const char *yopt, float ytick, int nysub);
 void cpgtext(float x, float y, const char *text);
 void cpgtick(float x1, float y1, float x2, float y2, float v, float tikl, float tikr, float disp, float orient, const char *str);
 void cpgupdt(void);
 void cpgvect(const float *ARRAY, const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, float c, int nc, const float *ARRAY, float blank);
 void cpgvsiz(float xleft, float xright, float ybot, float ytop);
 void cpgvstd(void);
 void cpgwedg(const char *side, float disp, float width, float fg, float bg, const char *label);
 void cpgwnad(float x1, float x2, float y1, float y2);

 void cpgimag(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, float a1, float a2, const float *ARRAY);
 void cpggray(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, float fg, float bg, const float *ARRAY);
 void cpgconb(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, const float *ARRAY, int nc, const float *ARRAY, float blank);
 void cpgconf(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, float c1, float c2, const float *ARRAY);
 void cpgconl(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, float c, const float *ARRAY, const char *label, int intval, int minint);
 void cpgcons(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, const float *ARRAY, int nc, const float *ARRAY);
 void cpgcont(const float *ARRAY, int idim, int jdim, int i1, int i2, int j1, int j2, const float *ARRAY, int nc, const float *ARRAY);

 void cpgpnts(int n, const float *ARRAY, const float *ARRAY, const int *ARRAY, int ns);
 void cpgline(int n, const float *ARRAY, const float *ARRAY);


